
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef rmp440_POSTER_LIB_H
#define rmp440_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "rmp440Type.h"
#include "rmp440Error.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[RMP440_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} RMP440_CNTRL_STR;

/* For consistency with other posters */
typedef RMP440_CNTRL_STR RMP440_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "rmp440PosterLibStruct.h"



/* Posters */
#define RMP440_CNTRL_POSTER_NAME genomInstanceSuffixName("rmp440", "Cntrl")
#define RMP440_MEPOS_POSTER_NAME genomInstanceSuffixName("rmp440", "MEPos")
#define RMP440_ODO_POSTER_NAME genomInstanceSuffixName("rmp440", "Odo")
#define RMP440_REF_POSTER_NAME genomInstanceSuffixName("rmp440", "Ref")
#define RMP440_STATUS_POSTER_NAME genomInstanceSuffixName("rmp440", "Status")
#define RMP440_STATUSGENERIC_POSTER_NAME genomInstanceSuffixName("rmp440", "StatusGeneric")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS rmp440PosterInit ( void );
extern POSTER_ID rmp440CntrlPosterID ();
extern STATUS rmp440CntrlPosterRead ( RMP440_CNTRL_STR *rmp440CntrlStrId );
extern STATUS rmp440CntrlPosterInit ( void );
extern STATUS rmp440CntrlInstancePosterRead(const char *name, RMP440_CNTRL_STR *rmp440CntrlStrId);
extern STATUS rmp440MEPosPosterInit ( void );
extern POSTER_ID rmp440MEPosPosterID ( void );
extern STATUS rmp440MEPosPosterRead ( RMP440_MEPOS_POSTER_STR *x );
extern STATUS rmp440MEPosInstancePosterRead ( const char *, RMP440_MEPOS_POSTER_STR * );
extern STATUS rmp440MEPosmePosPosterRead ( POM_ME_POS *mePos );
extern STATUS rmp440MEPosmePosInstancePosterRead( const char *, POM_ME_POS * );
extern STATUS rmp440OdoPosterInit ( void );
extern POSTER_ID rmp440OdoPosterID ( void );
extern STATUS rmp440OdoPosterRead ( RMP440_ODO_POSTER_STR *x );
extern STATUS rmp440OdoInstancePosterRead ( const char *, RMP440_ODO_POSTER_STR * );
extern STATUS rmp440OdoRobotPosterRead ( GENPOS_CART_STATE *Robot );
extern STATUS rmp440OdoRobotInstancePosterRead( const char *, GENPOS_CART_STATE * );
extern STATUS rmp440OdoVarPosterRead ( GENPOS_CART_CONFIG_VAR *Var );
extern STATUS rmp440OdoVarInstancePosterRead( const char *, GENPOS_CART_CONFIG_VAR * );
extern STATUS rmp440OdoRobot3dPosterRead ( RMP440_CART_3DSTATE *Robot3d );
extern STATUS rmp440OdoRobot3dInstancePosterRead( const char *, RMP440_CART_3DSTATE * );
extern STATUS rmp440RefPosterInit ( void );
extern POSTER_ID rmp440RefPosterID ( void );
extern STATUS rmp440RefPosterRead ( RMP440_REF_POSTER_STR *x );
extern STATUS rmp440RefInstancePosterRead ( const char *, RMP440_REF_POSTER_STR * );
extern STATUS rmp440RefrefPosterRead ( GENPOS_CART_REF *ref );
extern STATUS rmp440RefrefInstancePosterRead( const char *, GENPOS_CART_REF * );
extern STATUS rmp440StatusPosterInit ( void );
extern POSTER_ID rmp440StatusPosterID ( void );
extern STATUS rmp440StatusPosterRead ( RMP440_STATUS_POSTER_STR *x );
extern STATUS rmp440StatusInstancePosterRead ( const char *, RMP440_STATUS_POSTER_STR * );
extern STATUS rmp440StatusstatusPosterRead ( RMP440_STATUS_STR *status );
extern STATUS rmp440StatusstatusInstancePosterRead( const char *, RMP440_STATUS_STR * );
extern STATUS rmp440StatusGenericPosterInit ( void );
extern POSTER_ID rmp440StatusGenericPosterID ( void );
extern STATUS rmp440StatusGenericPosterRead ( RMP440_STATUSGENERIC_POSTER_STR *x );
extern STATUS rmp440StatusGenericInstancePosterRead ( const char *, RMP440_STATUSGENERIC_POSTER_STR * );
extern STATUS rmp440StatusGenericstatusgenPosterRead ( RMP_STATUS_STR *statusgen );
extern STATUS rmp440StatusGenericstatusgenInstancePosterRead( const char *, RMP_STATUS_STR * );
#ifdef __cplusplus
}
#endif
#endif

